#ifndef ethernetbasic_h
#define ethernetbasic_h

#include <inttypes.h>
#include "IPAddress.h"
#include "EthernetBasicClient.h"
#include "EthernetServer.h"

#define MAX_SOCK_NUM 4

class EthernetBasicClass {

private:

public:
  static uint8_t _state[MAX_SOCK_NUM];
  static uint16_t _server_port[MAX_SOCK_NUM];

  void beginBasic(uint8_t *mac_address, IPAddress local_ip, IPAddress gateway, IPAddress subnet = IPAddress(255, 255, 255, 0));

  IPAddress localIP();
  IPAddress subnetMask();
  IPAddress gatewayIP();

  friend class EthernetBasicClient;
  friend class EthernetServer;
};

#endif
