#ifndef ethernetbasicclient_h
#define ethernetbasicclient_h
#include "Arduino.h"	
#include "Print.h"
#include "Client.h"
#include "IPAddress.h"

class EthernetBasicClient : public Client {

public:
  EthernetBasicClient() { init(); }
  EthernetBasicClient(uint8_t sock)  { init(sock); }

  uint8_t status();
  virtual int connect(IPAddress ip, uint16_t port);
  virtual int connect(const char *host, uint16_t port) { return(0); }
  virtual size_t write(uint8_t);
  virtual size_t write(const uint8_t *buf, size_t size);
  virtual int available();
  virtual int read();
  virtual int read(uint8_t *buf, size_t size);
  virtual int peek();
  virtual void flush();
  virtual void stop();
  virtual uint8_t connected();
  virtual operator bool();
  uint8_t getSock() const { return(_sock); }

  friend class EthernetServer;
  
  using Print::write;

protected:
  inline void init(uint8_t sock = MAX_SOCK_NUM) { _sock = sock; }

private:
  static uint16_t _srcport;
  uint8_t _sock;
};

#endif
