// $Id: analogPinMap.c 28 2012-12-12 01:54:18Z Don $

/*-----------------------------------------------------------------------------
 *
 *	BSD License
 *  -----------
 *
 *  Copyright (c) 2012 Elba Corp.  All rights reserved.
 *
 *     Elba Corp.
 *     10915 SW Avocet Ct.
 *     Beaverton, OR  97007
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted only for use by licensees of the ZBasic
 *  Compiler for generic AVR devices and only then if all the following
 *  conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 *  - Neither the name of the copyright owner nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission of the copyright owner.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *-----------------------------------------------------------------------------*/

/*
 *
 * The contents of this file were derived, in part, from source files
 * distributed as part of the Arduino project.  The goal is to provide
 * an interface between Arduino functionality and ZBasic infrastructure
 * thus allowing Arduino code to be used in ZBasic applications.
 *
 */

/** include files **/
#include "zbasic_arduino.h"

/** local definitions **/

/** external functions **/

/** external data **/

/** callback functions **/

/** internal functions **/

/** public data **/

#if defined(USE_ANALOG_PIN_MAP)
// This array maps analog pin indices (0-N) to ADC selector value.
// The low 3 bits map directly to ADMUX2..ADMUX0 while the high bit,
// if asserted, indicates the "high bank" of ADC channels (ADC15-ADC8).
//
// This pin map is only needed if the target device has an unusual
// relationship between analog input numbers and ADC channel indices.  For
// most devices, there is a direct relationship so no mapping is needed.
const uint8_t analogPinMap[] PROGMEM =
{
#if defined(__AVR_ATmega16U4__) || defined(__AVR_ATmega32U4__)
	12,		// number of entries that follow

	0x07,	// A0		  F.7	 ADC7
	0x06,	// A1		  F.6	 ADC6	
	0x05,	// A2		  F.5	 ADC5	
	0x04,	// A3		  F.4	 ADC4
	0x01,	// A4		  F.1	 ADC1	
	0x00,	// A5		  F.0	 ADC0	
	0x80,	// A6	D4	  D.4	 ADC8
	0x82,	// A7	D6	  D.7	 ADC10
	0x83,	// A8	D8	  B.4	 ADC11
	0x84,	// A9	D9	  B.5	 ADC12
	0x85,	// A10	D10	  B.6	 ADC13
	0x81	// A11	D12	  D.6	 ADC9
#else
	// unknown device
	#error missing Arduino analog pin information
#endif
};
#endif

/** private data **/

/** public functions **/

/** interrupt handlers **/

/** private functions **/
