// $Id: detachInt.c 28 2012-12-12 01:54:18Z Don $

/*-----------------------------------------------------------------------------
 *
 *	BSD License
 *  -----------
 *
 *  Copyright (c) 2012 Elba Corp.  All rights reserved.
 *
 *     Elba Corp.
 *     10915 SW Avocet Ct.
 *     Beaverton, OR  97007
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted only for use by licensees of the ZBasic
 *  Compiler for generic AVR devices and only then if all the following
 *  conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 *  - Neither the name of the copyright owner nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission of the copyright owner.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *-----------------------------------------------------------------------------*/

/*
 *
 * The contents of this file were derived, in part, from source files
 * distributed as part of the Arduino project.  The goal is to provide
 * an interface between Arduino functionality and ZBasic infrastructure
 * thus allowing Arduino code to be used in ZBasic applications.
 *
 */

/** include files **/
#include "zbasic_arduino.h"

/** local definitions **/

/** external functions **/

/** external data **/

/** callback functions **/

/** internal functions **/

/** public data **/
volatile voidFuncPtr intFunc[NUM_EXT_INT];

/** private data **/

/** public functions **/

void
detachInterrupt(uint8_t intNum)
{
	if ((intNum >= NUM_EXT_INT) || (intNum >= __LPM(intNumMap)))
		return;
	intNum = __LPM(intNumMap + intNum + 1);
#if defined(EICRA) && defined(EICRB) && defined(EIMSK)
	EIMSK &= ~(1 << intNum);
#else
	switch (intNum)
	{
  #if defined(INT0)
	case 0:		EIMSK &= ~(1 << INT0);	break;
  #endif
  #if defined(INT1)
	case 1:		EIMSK &= ~(1 << INT1);	break;
  #endif
  #if defined(INT2)
	case 2:		EIMSK &= ~(1 << INT2);	break;
  #endif
  #if defined(INT3)
	case 3:		EIMSK &= ~(1 << INT3);	break;
  #endif
  #if defined(INT4)
	case 4:		EIMSK &= ~(1 << INT4);	break;
  #endif
  #if defined(INT5)
	case 5:		EIMSK &= ~(1 << INT5);	break;
  #endif
  #if defined(INT6)
	case 6:		EIMSK &= ~(1 << INT6);	break;
  #endif
  #if defined(INT7)
	case 7:		EIMSK &= ~(1 << INT7);	break;
  #endif
	}
#endif      
	intFunc[intNum] = 0;
}

/** interrupt handlers **/

/** private functions **/
