// $Id: digitalPinMap.c 33 2012-12-14 18:10:18Z Don $

/*-----------------------------------------------------------------------------
 *
 *	BSD License
 *  -----------
 *
 *  Copyright (c) 2012 Elba Corp.  All rights reserved.
 *
 *     Elba Corp.
 *     10915 SW Avocet Ct.
 *     Beaverton, OR  97007
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted only for use by licensees of the ZBasic
 *  Compiler for generic AVR devices and only then if all the following
 *  conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 *  - Neither the name of the copyright owner nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission of the copyright owner.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *-----------------------------------------------------------------------------*/

/*
 *
 * The contents of this file were derived, in part, from source files
 * distributed as part of the Arduino project.  The goal is to provide
 * an interface between Arduino functionality and ZBasic infrastructure
 * thus allowing Arduino code to be used in ZBasic applications.
 *
 */

/** include files **/
#include "zbasic_arduino.h"

/** local definitions **/

/** external functions **/

/** external data **/

/** callback functions **/

/** internal functions **/

/** public data **/

const uint8_t digitalPinMap[] PROGMEM =
{
#if defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)
	// this data matches the Arduino Duemilanove pinout
	20,		// number of entries that follow

	// AVR port/pin		Arduino pin
	ZB_PORT(D, 0),		//  0
	ZB_PORT(D, 1),		//  1
	ZB_PORT(D, 2),		//  2
	ZB_PORT(D, 3),		//  3
	ZB_PORT(D, 4),		//  4
	ZB_PORT(D, 5),		//  5
	ZB_PORT(D, 6),		//  6
	ZB_PORT(D, 7),		//  7
	ZB_PORT(B, 0),		//  8
	ZB_PORT(B, 1),		//  9
	ZB_PORT(B, 2),		// 10
	ZB_PORT(B, 3),		// 11
	ZB_PORT(B, 4),		// 12
	ZB_PORT(B, 5),		// 13

	// analog pins
	ZB_PORT(C, 0),		// 14
	ZB_PORT(C, 1),		// 15
	ZB_PORT(C, 2),		// 16
	ZB_PORT(C, 3),		// 17
	ZB_PORT(C, 4),		// 18
	ZB_PORT(C, 5)		// 19
#elif defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
	// this data matches the Arduino Mega pinout
	70,		// number of entries that follow

	// AVR port/pin		Arduino pin
	ZB_PORT(E, 0),		//  0
	ZB_PORT(E, 1),		//  1
	ZB_PORT(E, 4),		//  2
	ZB_PORT(E, 5),		//  3
	ZB_PORT(G, 5),		//  4
	ZB_PORT(E, 3),		//  5
	ZB_PORT(H, 3),		//  6
	ZB_PORT(H, 4),		//  7
	ZB_PORT(H, 5),		//  8
	ZB_PORT(H, 6),		//  9
	ZB_PORT(B, 4),		// 10
	ZB_PORT(B, 5),		// 11
	ZB_PORT(B, 6),		// 12
	ZB_PORT(B, 7),		// 13
	ZB_PORT(J, 1),		// 14
	ZB_PORT(J, 0),		// 15
	ZB_PORT(H, 1),		// 16
	ZB_PORT(H, 0),		// 17
	ZB_PORT(D, 3),		// 18
	ZB_PORT(D, 2),		// 19
	ZB_PORT(D, 1),		// 20
	ZB_PORT(D, 0),		// 21
	ZB_PORT(A, 0),		// 22
	ZB_PORT(A, 1),		// 23
	ZB_PORT(A, 2),		// 24
	ZB_PORT(A, 3),		// 25
	ZB_PORT(A, 4),		// 26
	ZB_PORT(A, 5),		// 27
	ZB_PORT(A, 6),		// 28
	ZB_PORT(A, 7),		// 29
	ZB_PORT(C, 7),		// 30
	ZB_PORT(C, 6),		// 31
	ZB_PORT(C, 5),		// 32
	ZB_PORT(C, 4),		// 33
	ZB_PORT(C, 3),		// 34
	ZB_PORT(C, 2),		// 35
	ZB_PORT(C, 1),		// 36
	ZB_PORT(C, 0),		// 37
	ZB_PORT(D, 7),		// 38
	ZB_PORT(G, 2),		// 39
	ZB_PORT(G, 1),		// 40
	ZB_PORT(G, 0),		// 41
	ZB_PORT(L, 7),		// 42
	ZB_PORT(L, 6),		// 43
	ZB_PORT(L, 5),		// 44
	ZB_PORT(L, 4),		// 45
	ZB_PORT(L, 3),		// 46
	ZB_PORT(L, 2),		// 47
	ZB_PORT(L, 1),		// 48
	ZB_PORT(L, 0),		// 49
	ZB_PORT(B, 3),		// 50
	ZB_PORT(B, 2),		// 51
	ZB_PORT(B, 1),		// 52
	ZB_PORT(B, 0),		// 53

	// analog pins
	ZB_PORT(F, 0),		// 54
	ZB_PORT(F, 1),		// 55
	ZB_PORT(F, 2),		// 56
	ZB_PORT(F, 3),		// 57
	ZB_PORT(F, 4),		// 58
	ZB_PORT(F, 5),		// 59
	ZB_PORT(F, 6),		// 60
	ZB_PORT(F, 7),		// 61
	ZB_PORT(K, 0),		// 62
	ZB_PORT(K, 1),		// 63
	ZB_PORT(K, 2),		// 64
	ZB_PORT(K, 3),		// 65
	ZB_PORT(K, 4),		// 66
	ZB_PORT(K, 5),		// 67
	ZB_PORT(K, 6),		// 68
	ZB_PORT(K, 7)		// 69
#elif defined(__AVR_ATmega164P__) || defined(__AVR_ATmega324P__) || \
		defined(__AVR_ATmega644__) || defined(__AVR_ATmega644P__) || \
		defined(__AVR_ATmega1284P__)
	// this data matches the Sanguino pinout
	32,		// number of entries that follow

	// AVR port/pin		Arduino pin
	ZB_PORT(B, 0),		//  0
	ZB_PORT(B, 1),		//  1
	ZB_PORT(B, 2),		//  2
	ZB_PORT(B, 3),		//  3
	ZB_PORT(B, 4),		//  4
	ZB_PORT(B, 5),		//  5
	ZB_PORT(B, 6),		//  6
	ZB_PORT(B, 7),		//  7
	ZB_PORT(D, 0),		//  8
	ZB_PORT(D, 1),		//  9
	ZB_PORT(D, 2),		// 10
	ZB_PORT(D, 3),		// 11
	ZB_PORT(D, 4),		// 12
	ZB_PORT(D, 5),		// 13
	ZB_PORT(D, 6),		// 14
	ZB_PORT(D, 7),		// 15
	ZB_PORT(C, 0),		// 16
	ZB_PORT(C, 1),		// 17
	ZB_PORT(C, 2),		// 18
	ZB_PORT(C, 3),		// 19
	ZB_PORT(C, 4),		// 20
	ZB_PORT(C, 5),		// 21
	ZB_PORT(C, 6),		// 22
	ZB_PORT(C, 7),		// 23

	// analog pins
	ZB_PORT(A, 7),		// 24
	ZB_PORT(A, 6),		// 25
	ZB_PORT(A, 5),		// 26
	ZB_PORT(A, 4),		// 27
	ZB_PORT(A, 3),		// 28
	ZB_PORT(A, 2),		// 29
	ZB_PORT(A, 1),		// 30
	ZB_PORT(A, 0)		// 31
#elif defined(__AVR_ATmega32U4__)
	// this data matches the Arduino Leonardo pinout
	30,		// number of entries that follow

	// AVR port/pin		Arduino pin
	ZB_PORT(D, 2),		//  0
	ZB_PORT(D, 3),		//  1
	ZB_PORT(D, 1),		//  2
	ZB_PORT(D, 0),		//  3
	ZB_PORT(D, 4),		//  4
	ZB_PORT(C, 6),		//  5
	ZB_PORT(D, 7),		//  6
	ZB_PORT(E, 6),		//  7
	ZB_PORT(B, 4),		//  8
	ZB_PORT(B, 5),		//  9
	ZB_PORT(B, 6),		// 10
	ZB_PORT(B, 7),		// 11
	ZB_PORT(D, 6),		// 12
	ZB_PORT(C, 7),		// 13
	ZB_PORT(B, 3),		// 14
	ZB_PORT(B, 1),		// 15
	ZB_PORT(B, 2),		// 16
	ZB_PORT(B, 0),		// 17

	// analog pins
	ZB_PORT(F, 7),		// 18
	ZB_PORT(F, 6),		// 19
	ZB_PORT(F, 5),		// 20
	ZB_PORT(F, 4),		// 21
	ZB_PORT(F, 1),		// 22
	ZB_PORT(F, 0),		// 23

	// note: these analog pins are duplicates of some digital pins above
	ZB_PORT(D, 4),		// 24
	ZB_PORT(D, 7),		// 25
	ZB_PORT(B, 4),		// 26
	ZB_PORT(B, 5),		// 27
	ZB_PORT(B, 6),		// 28
	ZB_PORT(D, 6),		// 29
#elif defined(__AVR_AT90USB646__) || defined(__AVR_AT90USB1286__)
	// this data matches the PJRC Teensy++ 2.0 pinout
	46,		// number of entries that follow

	// AVR port/pin		Arduino pin
	ZB_PORT(D, 0),		//  0
	ZB_PORT(D, 1),		//  1
	ZB_PORT(D, 2),		//  2
	ZB_PORT(D, 3),		//  3
	ZB_PORT(D, 4),		//  4
	ZB_PORT(D, 5),		//  5
	ZB_PORT(D, 6),		//  6
	ZB_PORT(D, 7),		//  7
	ZB_PORT(E, 0),		//  8
	ZB_PORT(E, 1),		//  9
	ZB_PORT(C, 0),		// 10
	ZB_PORT(C, 1),		// 11
	ZB_PORT(C, 2),		// 12
	ZB_PORT(C, 3),		// 13
	ZB_PORT(C, 4),		// 14
	ZB_PORT(C, 5),		// 15
	ZB_PORT(C, 6),		// 16
	ZB_PORT(C, 7),		// 17
	ZB_PORT(E, 6),		// 18
	ZB_PORT(E, 7),		// 19
	ZB_PORT(B, 0),		// 20
	ZB_PORT(B, 1),		// 21
	ZB_PORT(B, 2),		// 22
	ZB_PORT(B, 3),		// 23
	ZB_PORT(B, 4),		// 24
	ZB_PORT(B, 5),		// 25
	ZB_PORT(B, 6),		// 26
	ZB_PORT(B, 7),		// 27
	ZB_PORT(A, 0),		// 28
	ZB_PORT(A, 1),		// 29
	ZB_PORT(A, 2),		// 30
	ZB_PORT(A, 3),		// 31
	ZB_PORT(A, 4),		// 32
	ZB_PORT(A, 5),		// 33
	ZB_PORT(A, 6),		// 34
	ZB_PORT(A, 7),		// 35
	ZB_PORT(E, 4),		// 36
	ZB_PORT(E, 5),		// 37

	// analog pins
	ZB_PORT(F, 0),		// 38
	ZB_PORT(F, 1),		// 39
	ZB_PORT(F, 2),		// 40
	ZB_PORT(F, 3),		// 41
	ZB_PORT(F, 4),		// 42
	ZB_PORT(F, 5),		// 43
	ZB_PORT(F, 6),		// 44
	ZB_PORT(F, 7)		// 45
#else
	// unknown device
	0		// number of entries that follow

//	#error missing Arduino pin information
#endif
};

/** private data **/

/** public functions **/

/** interrupt handlers **/

/** private functions **/
