// $Id: intNumMap.c 28 2012-12-12 01:54:18Z Don $

/*-----------------------------------------------------------------------------
 *
 *	BSD License
 *  -----------
 *
 *  Copyright (c) 2012 Elba Corp.  All rights reserved.
 *
 *     Elba Corp.
 *     10915 SW Avocet Ct.
 *     Beaverton, OR  97007
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted only for use by licensees of the ZBasic
 *  Compiler for generic AVR devices and only then if all the following
 *  conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 *  - Neither the name of the copyright owner nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission of the copyright owner.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *-----------------------------------------------------------------------------*/

/*
 *
 * The contents of this file were derived, in part, from source files
 * distributed as part of the Arduino project.  The goal is to provide
 * an interface between Arduino functionality and ZBasic infrastructure
 * thus allowing Arduino code to be used in ZBasic applications.
 *
 */

/** include files **/
#include "zbasic_arduino.h"

/** local definitions **/

/** external functions **/

/** external data **/

/** callback functions **/

/** internal functions **/

/** public data **/

//
// This table maps the Arduino interrupt number to the AVR
// external interrupt number.  The first entry in the table
// indicates the number of entries that follow.
const uint8_t intNumMap[] PROGMEM =
{
#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
		8,		// number of entries that follow

	// Ext.		Arduino
	// IntNum	IntNum
		4,		//  0
		5,		//  1
		0,		//  2
		1,		//  3
		2,		//  4
		3,		//  5
		6,		//  6
		7		//  7
#elif defined(__AVR_ATmega164P__) || defined(__AVR_ATmega324P__) || \
		defined(__AVR_ATmega644__) || defined(__AVR_ATmega644P__) || \
		defined(__AVR_ATmega1284P__)
		3,		// number of entries that follow

	// Ext.		Arduino
	// IntNum	IntNum
		0,		//  0
		1,		//  1
		2,		//  2
#elif defined(__AVR_ATmega32U4__)
		4,		// number of entries that follow

	// Ext.		Arduino
	// IntNum	IntNum
		0,		//  0
		1,		//  1
		2,		//  2
		3,		//  3
#elif defined(__AVR_AT90USB646__) || defined(__AVR_AT90USB1286__)
		8,		// number of entries that follow

	// Ext.		Arduino
	// IntNum	IntNum
		0,		//  0
		1,		//  1
		2,		//  2
		3,		//  3
		4,		//  4
		5,		//  5
		6,		//  6
		7		//  7
#elif defined(__AVR_ATmega168P__) || defined(__AVR_ATmega328P__)
		2,		// number of entries that follow

	// Ext.		Arduino
	// IntNum	IntNum
		0,		//  0
		1,		//  1
#else
	// unknown device
		0
//	#error missing Arduino intNum information
#endif
};

/** private data **/

/** public functions **/

/** interrupt handlers **/

/** private functions **/
